#include <ultra64.h>
#include "sm64.h"
#include "behavior_data.h"
#include "model_ids.h"
#include "seq_ids.h"
#include "dialog_ids.h"
#include "segment_symbols.h"
#include "level_commands.h"
#include "game/level_update.h"
#include "levels/scripts.h"
#include "actors/common1.h"
#include "make_const_nonconst.h"

#include "areas/1/custom.model.inc.h"
#include "levels/bob/header.h"
extern u8 _bob_segment_ESegmentRomStart[]; 
extern u8 _bob_segment_ESegmentRomEnd[];
#include "levels/wf/header.h"
const LevelScript level_bob_entry[] = {
INIT_LEVEL(),
LOAD_MIO0(0x07, _wf_segment_7SegmentRomStart, _wf_segment_7SegmentRomEnd),
LOAD_RAW(0x1A, _wfSegmentRomStart, _wfSegmentRomEnd),
LOAD_RAW(0x0E, _bob_segment_ESegmentRomStart, _bob_segment_ESegmentRomEnd),
LOAD_MIO0(0xA,_water_skybox_mio0SegmentRomStart,_water_skybox_mio0SegmentRomEnd),
LOAD_MIO0(8,_common0_mio0SegmentRomStart,_common0_mio0SegmentRomEnd),
LOAD_RAW(15,_common0_geoSegmentRomStart,_common0_geoSegmentRomEnd),
LOAD_MIO0(5,_group11_mio0SegmentRomStart,_group11_mio0SegmentRomEnd),
LOAD_RAW(12,_group11_geoSegmentRomStart,_group11_geoSegmentRomEnd),
LOAD_MIO0(6,_group13_mio0SegmentRomStart,_group13_mio0SegmentRomEnd),
LOAD_RAW(13,_group13_geoSegmentRomStart,_group13_geoSegmentRomEnd),
ALLOC_LEVEL_POOL(),
MARIO(/*model*/ MODEL_MARIO, /*behParam*/ 0x00000001, /*beh*/ bhvMario),
LOAD_MODEL_FROM_GEO(MODEL_WF_BUBBLY_TREE,                   bubbly_tree_geo),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_03,                wf_geo_0007E0),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_04,                wf_geo_000820),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_05,                wf_geo_000860),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_06,                wf_geo_000878),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_07,                wf_geo_000890),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_08,                wf_geo_0008A8),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_09,                wf_geo_0008E8),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_0A,                wf_geo_000900),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_0C,                wf_geo_000940),
    LOAD_MODEL_FROM_GEO(MODEL_WF_GIANT_POLE,                    wf_geo_000AE0),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_0E,                wf_geo_000958),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_0F,                wf_geo_0009A0),
    LOAD_MODEL_FROM_GEO(MODEL_WF_ROTATING_PLATFORM,             wf_geo_0009B8),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_11,                wf_geo_0009D0),
    LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_12,                wf_geo_0009E8),
    LOAD_MODEL_FROM_GEO(MODEL_WF_SMALL_BOMP,                    wf_geo_000A00),
    LOAD_MODEL_FROM_GEO(MODEL_WF_LARGE_BOMP,                    wf_geo_000A40),
    LOAD_MODEL_FROM_GEO(MODEL_WF_ROTATING_WOODEN_PLATFORM,      wf_geo_000A58),
    LOAD_MODEL_FROM_GEO(MODEL_WF_SLIDING_PLATFORM,              wf_geo_000A98),
    LOAD_MODEL_FROM_GEO(MODEL_WF_TUMBLING_BRIDGE_PART,          wf_geo_000AB0),
    LOAD_MODEL_FROM_GEO(MODEL_WF_TUMBLING_BRIDGE,               wf_geo_000AC8),
    LOAD_MODEL_FROM_GEO(MODEL_WF_TOWER_TRAPEZOID_PLATORM,       wf_geo_000AF8),
    LOAD_MODEL_FROM_GEO(MODEL_WF_TOWER_SQUARE_PLATORM,          wf_geo_000B10),
    LOAD_MODEL_FROM_GEO(MODEL_WF_TOWER_SQUARE_PLATORM_UNUSED,   wf_geo_000B38),
    LOAD_MODEL_FROM_GEO(MODEL_WF_TOWER_SQUARE_PLATORM_ELEVATOR, wf_geo_000B60),
    LOAD_MODEL_FROM_GEO(MODEL_WF_BREAKABLE_WALL_RIGHT,          wf_geo_000B78),
    LOAD_MODEL_FROM_GEO(MODEL_WF_BREAKABLE_WALL_LEFT,           wf_geo_000B90),
    LOAD_MODEL_FROM_GEO(MODEL_WF_KICKABLE_BOARD,                wf_geo_000BA8),
    LOAD_MODEL_FROM_GEO(MODEL_WF_TOWER_DOOR,                    wf_geo_000BE0),
    LOAD_MODEL_FROM_GEO(MODEL_WF_KICKABLE_BOARD_FELLED,         wf_geo_000BC8),
LOAD_MODEL_FROM_GEO(22, warp_pipe_geo),
LOAD_MODEL_FROM_GEO(23, bubbly_tree_geo),
LOAD_MODEL_FROM_GEO(24, spiky_tree_geo),
LOAD_MODEL_FROM_GEO(25, snow_tree_geo),
LOAD_MODEL_FROM_GEO(27, palm_tree_geo),
LOAD_MODEL_FROM_GEO(31, metal_door_geo),
LOAD_MODEL_FROM_GEO(32, hazy_maze_door_geo),
LOAD_MODEL_FROM_GEO(34, castle_door_0_star_geo),
LOAD_MODEL_FROM_GEO(35, castle_door_1_star_geo),
LOAD_MODEL_FROM_GEO(36, castle_door_3_stars_geo),
LOAD_MODEL_FROM_GEO(37, key_door_geo),
LOAD_MODEL_FROM_GEO(38, castle_door_geo),
// LOAD_MODEL_FROM_GEO(88,0x0500c778),
// LOAD_MODEL_FROM_DL(132,0x08025f08,4),
// LOAD_MODEL_FROM_DL(158,0x0302c8a0,4),
// LOAD_MODEL_FROM_DL(159,0x0302bcd0,4),
// LOAD_MODEL_FROM_DL(161,0x0301cb00,4),
// LOAD_MODEL_FROM_DL(164,0x04032a18,4),
// LOAD_MODEL_FROM_DL(201,0x080048e0,4),
// LOAD_MODEL_FROM_DL(218,0x08024bb8,4),
JUMP_LINK(script_func_global_1),
JUMP_LINK(script_func_global_12),
JUMP_LINK(script_func_global_14),
JUMP_LINK(local_area_bob_1_),
FREE_LEVEL_POOL(),
MARIO_POS(1,0,0,0,0),
CALL(/*arg*/ 0, /*func*/ lvl_init_or_update),
CALL_LOOP(/*arg*/ 1, /*func*/ lvl_init_or_update),
CLEAR_LEVEL(),
SLEEP_BEFORE_EXIT(/*frames*/ 1),
EXIT(),
};
const LevelScript local_area_bob_1_[] = {
AREA(1,Geo_bob_1_0x1254190),
TERRAIN(col_bob_1_0xe018a60),
SET_BACKGROUND_MUSIC(0,1),
TERRAIN_TYPE(0),
JUMP_LINK(local_objects_bob_1_),
JUMP_LINK(local_warps_bob_1_),
END_AREA(),
RETURN()
};
const LevelScript local_objects_bob_1_[] = {
OBJECT_WITH_ACTS(0,2099,1170,-7975,0,0,0,0xa0000, bhvSpinAirborneWarp,31),
OBJECT_WITH_ACTS(122,5247,150,-7782,0,0,0,0x0, bhvStar,31),
OBJECT_WITH_ACTS(122,5236,2430,-5548,0,0,0,0x1000000, bhvStar,31),
OBJECT_WITH_ACTS(195,4508,749,-8092,0,0,0,0x0, bhvBobombBuddy,31),
OBJECT_WITH_ACTS(137,9742,720,-6939,0,0,0,0xb0000, bhvExclamationBox,31),
OBJECT_WITH_ACTS(129,5271,2850,-7691,0,0,0,0x30000, bhvBreakableBox,31),
OBJECT_WITH_ACTS(129,5273,2850,-7950,0,0,0,0x30000, bhvBreakableBox,31),
OBJECT_WITH_ACTS(215,4896,749,-9687,0,0,0,0x0, bhvRedCoin,31),
OBJECT_WITH_ACTS(215,5266,3070,-9571,0,0,0,0x0, bhvRedCoin,31),
OBJECT_WITH_ACTS(215,11101,749,-8974,0,0,0,0x0, bhvRedCoin,31),
OBJECT_WITH_ACTS(129,9385,779,-6962,0,0,0,0x30000, bhvBreakableBox,31),
OBJECT_WITH_ACTS(0,5340,929,-14295,0,0,0,0x3000000, bhvHiddenRedCoinStar,31),
OBJECT_WITH_ACTS(192,4575,749,-11789,0,0,0,0x0, bhvGoomba,31),
OBJECT_WITH_ACTS(223,5572,839,-3735,0,0,0,0x0, bhvChuckya,31),
OBJECT_WITH_ACTS(140,4604,749,-8625,0,0,0,0x0, bhvBlueCoinSwitch,31),
OBJECT_WITH_ACTS(118,5277,1260,-8889,0,0,0,0x0, bhvHiddenBlueCoin,31),
OBJECT_WITH_ACTS(118,5151,1950,-8518,0,0,0,0x0, bhvHiddenBlueCoin,31),
OBJECT_WITH_ACTS(118,5117,2370,-8872,0,0,0,0x0, bhvHiddenBlueCoin,31),
OBJECT_WITH_ACTS(84,291,749,-5277,0,0,0,0x0, bhvEnemyLakitu,31),
OBJECT_WITH_ACTS(0,-112,749,-7796,0,0,0,0x0, bhvCoinFormation,31),
OBJECT_WITH_ACTS(0,-624,749,-8829,0,0,0,0x0, bhvCoinFormation,31),
OBJECT_WITH_ACTS(0,45,749,-5868,0,0,0,0x0, bhvCoinFormation,31),
OBJECT_WITH_ACTS(0,218,749,-9947,0,0,0,0x0, bhvCoinFormation,31),
OBJECT_WITH_ACTS(0,959,749,-6719,0,0,0,0x0, bhvCoinFormation,31),
OBJECT_WITH_ACTS(215,9767,839,-11231,0,0,0,0x0, bhvRedCoin,31),
OBJECT_WITH_ACTS(84,4870,749,-3398,0,0,0,0x0, bhvEnemyLakitu,31),
OBJECT_WITH_ACTS(223,1420,749,-12661,0,2,0,0x0, bhvChuckya,31),
OBJECT_WITH_ACTS(223,3505,754,-8076,0,0,0,0x0, bhvChuckya,31),
OBJECT_WITH_ACTS(223,4256,749,-5568,0,0,0,0x0, bhvChuckya,31),
OBJECT_WITH_ACTS(223,-8,749,-4135,0,0,0,0x0, bhvChuckya,31),
OBJECT_WITH_ACTS(223,2607,749,-3375,0,0,0,0x0, bhvChuckya,31),
OBJECT_WITH_ACTS(24,-214,749,-6777,0,0,0,0x0, bhvTree,31),
OBJECT_WITH_ACTS(24,656,749,-8775,0,0,0,0x0, bhvTree,31),
OBJECT_WITH_ACTS(24,761,749,-4094,0,0,0,0x0, bhvTree,31),
OBJECT_WITH_ACTS(24,2370,749,-4721,0,0,0,0x0, bhvTree,31),
OBJECT_WITH_ACTS(24,969,749,-11268,0,0,0,0x0, bhvTree,31),
OBJECT_WITH_ACTS(24,7794,749,-12913,0,0,0,0x0, bhvTree,31),
OBJECT_WITH_ACTS(24,8403,749,-4136,0,0,0,0x0, bhvTree,31),
OBJECT_WITH_ACTS(24,11258,749,-6350,0,0,0,0x0, bhvTree,31),
OBJECT_WITH_ACTS(24,3332,749,-13458,0,0,0,0x0, bhvTree,31),
OBJECT_WITH_ACTS(24,6720,749,-8701,0,0,0,0x0, bhvTree,31),
OBJECT_WITH_ACTS(195,2320,749,-7527,0,0,0,0x0, bhvBobombBuddyOpensCannon,31),
RETURN()
};
const LevelScript local_warps_bob_1_[] = {
WARP_NODE(10,9,1,0,0),
WARP_NODE(240,6,1,50,0),
WARP_NODE(241,6,1,100,0),
RETURN()
};
